// Generated by LiveScript 1.5.0
var uuid, waitUntil, WebSocketServer, debug, MockExoCom, slice$ = [].slice;
uuid = require('uuid');
waitUntil = require('wait').waitUntil;
WebSocketServer = require('ws').Server;
debug = require('debug')('exocom-mock');
MockExoCom = (function(){
  MockExoCom.displayName = 'MockExoCom';
  var prototype = MockExoCom.prototype, constructor = MockExoCom;
  function MockExoCom(){
    this._onSocketMessage = bind$(this, '_onSocketMessage', prototype);
    this._onServerConnection = bind$(this, '_onServerConnection', prototype);
    this._onMessage = bind$(this, '_onMessage', prototype);
    this.send = bind$(this, 'send', prototype);
    this.reset = bind$(this, 'reset', prototype);
    this.registerService = bind$(this, 'registerService', prototype);
    this.onReceive = bind$(this, 'onReceive', prototype);
    this.listen = bind$(this, 'listen', prototype);
    this.close = bind$(this, 'close', prototype);
    this.server = null;
    this.port = null;
    this.serviceSockets = {};
    this.receivedMessages = [];
    this.receiveCallback = null;
  }
  MockExoCom.prototype.close = function(done){
    switch (false) {
    case !this.server:
      return this.server.close(done);
    default:
      return done();
    }
  };
  MockExoCom.prototype.knowsService = function(name){
    return !!this.serviceSockets[name];
  };
  MockExoCom.prototype.listen = function(port, done){
    var x$;
    this.port = +port;
    x$ = this.server = new WebSocketServer({
      port: this.port
    }, done);
    x$.on('error', this._onServerError);
    x$.on('connection', this._onServerConnection);
    return x$;
  };
  MockExoCom.prototype.onReceive = function(receiveCallback){
    this.receiveCallback = receiveCallback;
    if (this.receivedMessages.length) {
      return this.receiveCallback();
    }
  };
  MockExoCom.prototype.registerService = function(arg$){
    var name, websocket;
    name = arg$.name, websocket = arg$.websocket;
    return this.serviceSockets[name] = websocket;
  };
  MockExoCom.prototype.reset = function(){
    return this.receivedMessages = [];
  };
  MockExoCom.prototype.send = function(arg$){
    var service, name, payload, messageId, responseTo, requestData;
    service = arg$.service, name = arg$.name, payload = arg$.payload, messageId = arg$.messageId, responseTo = arg$.responseTo;
    switch (false) {
    case !!this.serviceSockets[service]:
      throw new Error("unknown service: '" + service + "'");
    }
    this.receivedMessages = [];
    requestData = {
      name: name,
      payload: payload,
      id: messageId || uuid.v1()
    };
    if (responseTo) {
      requestData.responseTo = responseTo;
    }
    return this.serviceSockets[service].send(JSON.stringify(requestData));
  };
  MockExoCom.prototype.waitUntilKnowsService = function(name, done){
    var this$ = this;
    return waitUntil(function(){
      return this$.knowsService(name);
    }, 1, done);
  };
  MockExoCom.prototype._onMessage = function(data){
    this.receivedMessages.push(data);
    return typeof this.receiveCallback == 'function' ? this.receiveCallback() : void 8;
  };
  MockExoCom.prototype._onServerConnection = function(websocket){
    return websocket.on('message', partialize$.apply(this, [this._onSocketMessage, [void 8, websocket], [0]]));
  };
  MockExoCom.prototype._onServerError = function(error){
    return console.log(error);
  };
  MockExoCom.prototype._onSocketMessage = function(message, websocket){
    var requestData;
    switch ((requestData = JSON.parse(message)).name) {
    case 'exocom.register-service':
      this.registerService({
        name: requestData.sender,
        websocket: websocket
      });
    }
    return this._onMessage(requestData);
  };
  return MockExoCom;
}());
module.exports = MockExoCom;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function partialize$(f, args, where){
  var context = this;
  return function(){
    var params = slice$.call(arguments), i,
        len = params.length, wlen = where.length,
        ta = args ? args.concat() : [], tw = where ? where.concat() : [];
    for(i = 0; i < len; ++i) { ta[tw[0]] = params[i]; tw.shift(); }
    return len < wlen && len ?
      partialize$.apply(context, [f, ta, tw]) : f.apply(context, ta);
  };
}